
#include <string.h>
#include <stdio.h>

#include "iface.h"
#include "buspirate.h"
#include "usbasp.h"

#define IFACE_CNT (sizeof(iface)/sizeof(struct iface_t))
struct iface_t *iface[] = {
	&buspirate_iface,
	&usbasp_iface,
	NULL
};

struct iface_t *Iface_GetByName(char *name) {
	struct iface_t *dev;
	int i;
	
	if (name == NULL) return NULL;

	for (i = 0; iface[i] != NULL; i++) {
		if (strcasecmp(name, iface[i]->name) == 0) {
			return (struct iface_t *)iface[i];
		}
	}
	return NULL;
}

void Iface_ListProgrammers(void)
{
	int i;
	for (i = 0; iface[i] != NULL; i++) {
		printf("\t%s\n", iface[i]->name);
	}
}
